import requests
import json
from common_utils import *


def get_apstoken():
    auth = 'REFJVkJBRE1fTUlDVE1fQ05fUFJPRF8wMDMyNjowZTJmRVNNfnlnOHJvSWo2NXUtN18zWUoxLlY0RjlOVQ=='
    scope = 'openid groups audience:server:client_id:DAIVBADM_MICTM_CN_PROD_00333'
    resBody = getToken(auth, scope).json()
    return resBody['id_token']


def get_apsdesired(vin, meId):
    requests.packages.urllib3.disable_warnings(requests.packages.urllib3.exceptions.InsecureRequestWarning)

    url = 'https://aps.azure.mercedes-benz.com.cn/ncp/aps/v1.0/users/' + meId + '/vehicles/' + vin + '/applications/desiredstate'

    headers = {
        'Authorization': 'Bearer ' + get_apstoken()
    }

    res =  requests.get(url, headers=headers, verify=False, proxies=proxyDict)
    #res =  requests.get(url, headers=headers, verify=False, proxies=proxyDict, hooks={'response': print_roundtrip})

    if res.status_code != 200:
        if res.status_code != 404:
            print('[ERROR]failed to get APS desiredstate of [' + vin + ', ' + meId + ']')
        else:
            print('[' + vin + ', ' + meId + '] has no APS desired')
        return None

    return res.json()


def appdesired_clearbyname(vin, meId, appname):
    desired = get_apsdesired(vin, meId)
    if not desired: return None

    filtered_desired = []
    for item in desired['desired']:
        timename = item['name']
        if not timename.lower().startswith(appname.lower()):
            filtered_desired.append(item)
        else:
            print('[INFO]['+ vin + ', ' + meId + '] has "' + timename + '" in APS desired, need to clear')

    # if no app to be deleted, don't update APS desire
    if len(desired['desired']) == len(filtered_desired):
        return None

    desired['desired'] = filtered_desired
    return desired


def appdesired_clearbyuid(vin, meId, uid):
    desired = get_apsdesired(vin, meId)
    if not desired: return None

    filtered_desired = []
    for item in desired['desired']:
        itemuid = item['uid']
        if not (itemuid == uid):
            filtered_desired.append(item)
        else:
            print('[INFO]['+ vin + ', ' + meId + '] has "' + itemuid + '" in APS desired, need to clear')

    # if no app to be deleted, don't update APS desire
    if len(desired['desired']) == len(filtered_desired):
        return None

    desired['desired'] = filtered_desired
    return desired


def appdesired_forceuninstall(vin, meId, appname):
    desired = get_apsdesired(vin, meId)
    if not desired: return None

    hasnfs = False
    for item in desired['desired']:
        if item['name'].lower().startswith(appname.lower()) and item['state'] != 'forceUninstalled':
            item['state'] = 'forceUninstalled'
            hasnfs = True

            print('[INFO]['+ vin + ', ' + meId + '] master user has "' + appname + '" in APS desired, need to force uninstall')
            break

    # if no NFS, don't update APS desire
    if hasnfs:
        return desired
    else:
        return None



def post_apsdesired(vin, meId, newdesired):
    if not newdesired: return

    print('update aps desire')

    requests.packages.urllib3.disable_warnings(requests.packages.urllib3.exceptions.InsecureRequestWarning)

    url = 'https://aps.azure.mercedes-benz.com.cn/ncp/aps/v1.0/users/' + meId + '/vehicles/' + vin + '/applications/desiredstate'

    headers = {
        'Authorization': 'Bearer ' + get_apstoken()
    }

    res =  requests.post(url, headers=headers, data=json.dumps(newdesired), verify=False, proxies=proxyDict)
    #res =  requests.post(url, headers=headers, data=json.dumps(newdesired), verify=False, proxies=proxyDict, hooks={'response': print_roundtrip})

    if res.status_code != 200:
        print('[ERROR]failed to update APS desiredstate of [' + vin + ', ' + meId + ']')


#print(appdesired_clear('LE4FG1DB8SL000041', 'GUEST', 'Yunting_Radio_i3'))